diff --git a/pidgin/pidginconversationwindow.c b/pidgin/pidginconversationwindow.c
--- a/pidgin/pidginconversationwindow.c
+++ b/pidgin/pidginconversationwindow.c
@@ -22,19 +22,101 @@
 
 #include "pidginconversationwindow.h"
 
+#include "gtkconv.h"
+
+enum {
+	PIDGIN_CONVERSATION_WINDOW_COLUMN_OBJECT,
+	PIDGIN_CONVERSATION_WINDOW_COLUMN_ICON,
+	PIDGIN_CONVERSATION_WINDOW_COLUMN_MARKUP,
+};
+
+enum {
+	SIG_CONVERSATION_SWITCHED,
+	N_SIGNALS,
+};
+static guint signals[N_SIGNALS] = {0, };
+
 struct _PidginConversationWindow {
 	GtkApplicationWindow parent;
 
 	GtkWidget *vbox;
+
+	GtkWidget *view;
+	GtkTreeStore *model;
+
+	GtkWidget *stack;
 };
 
 G_DEFINE_TYPE(PidginConversationWindow, pidgin_conversation_window,
               GTK_TYPE_APPLICATION_WINDOW)
 
+static GtkWidget *default_window = NULL;
+
+/******************************************************************************
+ * Callbacks
+ *****************************************************************************/
+static void
+pidgin_conversation_window_selection_changed(GtkTreeSelection *selection,
+                                             gpointer data)
+{
+	PidginConversationWindow *window = PIDGIN_CONVERSATION_WINDOW(data);
+	GtkTreeModel *model = NULL;
+	GtkTreeIter iter;
+	gboolean changed = FALSE;
+
+	if(gtk_tree_selection_get_selected(selection, &model, &iter)) {
+		gchar *markup = NULL;
+
+		gtk_tree_model_get(model, &iter,
+		                   PIDGIN_CONVERSATION_WINDOW_COLUMN_MARKUP, &markup,
+		                   -1);
+
+		gtk_stack_set_visible_child_name(GTK_STACK(window->stack), markup);
+		g_free(markup);
+
+		changed = TRUE;
+	}
+
+	if(!changed) {
+		gtk_stack_set_visible_child_name(GTK_STACK(window->stack), "__empty__");
+	}
+}
+
+static gboolean
+pidgin_conversation_window_foreach_destroy(GtkTreeModel *model,
+                                           GtkTreePath *path,
+                                           GtkTreeIter *iter,
+                                           gpointer data)
+{
+	PurpleConversation *conversation = NULL;
+
+	gtk_tree_model_get(model, iter,
+	                   PIDGIN_CONVERSATION_WINDOW_COLUMN_OBJECT, &conversation,
+	                   -1);
+
+	if(conversation != NULL) {
+		pidgin_conversation_detach(conversation);
+	}
+
+	return FALSE;
+}
+
 /******************************************************************************
  * GObjectImplementation
  *****************************************************************************/
 static void
+pidgin_conversation_window_dispose(GObject *obj) {
+	PidginConversationWindow *window = PIDGIN_CONVERSATION_WINDOW(obj);
+
+	if(GTK_IS_TREE_MODEL(window->model)) {
+		gtk_tree_model_foreach(GTK_TREE_MODEL(window->model),
+		                       pidgin_conversation_window_foreach_destroy, window);
+	}
+
+	G_OBJECT_CLASS(pidgin_conversation_window_parent_class)->dispose(obj);
+}
+
+static void
 pidgin_conversation_window_init(PidginConversationWindow *window) {
 	GtkBuilder *builder = NULL;
 	GtkWidget *menubar = NULL;
@@ -50,6 +132,7 @@
 
 	model = (GMenuModel *)gtk_builder_get_object(builder, "conversation");
 	menubar = gtk_menu_bar_new_from_model(model);
+
 	gtk_box_pack_start(GTK_BOX(window->vbox), menubar, FALSE, FALSE, 0);
 	gtk_widget_show(menubar);
 
@@ -58,8 +141,24 @@
 
 static void
 pidgin_conversation_window_class_init(PidginConversationWindowClass *klass) {
+	GObjectClass *obj_class = G_OBJECT_CLASS(klass);
 	GtkWidgetClass *widget_class = GTK_WIDGET_CLASS(klass);
 
+	obj_class->dispose = pidgin_conversation_window_dispose;
+
+	signals[SIG_CONVERSATION_SWITCHED] = g_signal_new_class_handler(
+		"conversation-switched",
+		G_OBJECT_CLASS_TYPE(obj_class),
+		G_SIGNAL_RUN_LAST,
+		NULL,
+		NULL,
+		NULL,
+		NULL,
+		G_TYPE_NONE,
+		1,
+		PURPLE_TYPE_CONVERSATION
+	);
+
 	gtk_widget_class_set_template_from_resource(
 	    widget_class,
 	    "/im/pidgin/Pidgin3/Conversations/window.ui"
@@ -67,19 +166,274 @@
 
 	gtk_widget_class_bind_template_child(widget_class, PidginConversationWindow,
 	                                     vbox);
+
+	gtk_widget_class_bind_template_child(widget_class, PidginConversationWindow,
+	                                     model);
+	gtk_widget_class_bind_template_child(widget_class, PidginConversationWindow,
+	                                     view);
+
+	gtk_widget_class_bind_template_child(widget_class, PidginConversationWindow,
+	                                     stack);
+
+	gtk_widget_class_bind_template_callback(widget_class,
+	                                        pidgin_conversation_window_selection_changed);
 }
 
 /******************************************************************************
  * API
  *****************************************************************************/
 GtkWidget *
+pidgin_conversation_window_get_default(void) {
+	if(!GTK_IS_WIDGET(default_window)) {
+		default_window = pidgin_conversation_window_new();
+		g_object_add_weak_pointer(G_OBJECT(default_window),
+		                          (gpointer)&default_window);
+	}
+
+	return default_window;
+}
+
+GtkWidget *
 pidgin_conversation_window_new(void) {
 	return GTK_WIDGET(g_object_new(PIDGIN_TYPE_CONVERSATION_WINDOW, NULL));
 }
 
-GtkWidget *
-pidgin_conversation_window_get_vbox(PidginConversationWindow *window) {
+void
+pidgin_conversation_window_add(PidginConversationWindow *window,
+                               PurpleConversation *conversation)
+{
+	PidginConversation *gtkconv = NULL;
+	GtkTreeIter iter;
+	const gchar *markup = NULL;
+
+	g_return_if_fail(PIDGIN_IS_CONVERSATION_WINDOW(window));
+	g_return_if_fail(PURPLE_IS_CONVERSATION(conversation));
+
+	markup = purple_conversation_get_name(conversation);
+
+	gtkconv = PIDGIN_CONVERSATION(conversation);
+	if(gtkconv != NULL) {
+		GtkWidget *parent = gtk_widget_get_parent(gtkconv->tab_cont);
+
+		if(GTK_IS_WIDGET(parent)) {
+			g_object_ref(gtkconv->tab_cont);
+			gtk_container_remove(GTK_CONTAINER(parent), gtkconv->tab_cont);
+		}
+
+		gtk_stack_add_named(GTK_STACK(window->stack), gtkconv->tab_cont, markup);
+		gtk_widget_show_all(gtkconv->tab_cont);
+
+		if(GTK_IS_WIDGET(parent)) {
+			g_object_unref(gtkconv->tab_cont);
+		}
+	}
+
+	gtk_tree_store_prepend(window->model, &iter, NULL);
+	gtk_tree_store_set(window->model, &iter,
+	                   PIDGIN_CONVERSATION_WINDOW_COLUMN_OBJECT, conversation,
+	                   PIDGIN_CONVERSATION_WINDOW_COLUMN_MARKUP, markup,
+	                   -1);
+
+	if(!gtk_widget_is_visible(GTK_WIDGET(window))) {
+		gtk_widget_show_all(GTK_WIDGET(window));
+	}
+}
+
+void
+pidgin_conversation_window_remove(PidginConversationWindow *window,
+                                  PurpleConversation *conversation)
+{
+	GtkTreeIter iter;
+	GObject *obj = NULL;
+
+	g_return_if_fail(PIDGIN_IS_CONVERSATION_WINDOW(window));
+	g_return_if_fail(PURPLE_IS_CONVERSATION(conversation));
+
+	if(!gtk_tree_model_get_iter_first(GTK_TREE_MODEL(window->model), &iter)) {
+		/* The tree is empty. */
+		return;
+	}
+
+	do {
+		gtk_tree_model_get(GTK_TREE_MODEL(window->model), &iter,
+		                   PIDGIN_CONVERSATION_WINDOW_COLUMN_OBJECT, &obj,
+		                   -1);
+
+		if(PURPLE_CONVERSATION(obj) == conversation) {
+			gtk_tree_store_remove(window->model, &iter);
+
+			g_clear_object(&obj);
+
+			break;
+		}
+
+		g_clear_object(&obj);
+	} while(gtk_tree_model_iter_next(GTK_TREE_MODEL(window->model), &iter));
+}
+
+guint
+pidgin_conversation_window_get_count(PidginConversationWindow *window) {
+	GList *children = NULL;
+	guint count = 0;
+
+	g_return_val_if_fail(PIDGIN_IS_CONVERSATION_WINDOW(window), 0);
+
+	children = gtk_container_get_children(GTK_CONTAINER(window));
+	while(children != NULL) {
+		children = g_list_delete_link(children, children);
+		count++;
+	}
+
+	return count;
+}
+
+PurpleConversation *
+pidgin_conversation_window_get_selected(PidginConversationWindow *window) {
+	PurpleConversation *conversation = NULL;
+	GtkTreeSelection *selection = NULL;
+	GtkTreeIter iter;
+
 	g_return_val_if_fail(PIDGIN_IS_CONVERSATION_WINDOW(window), NULL);
 
-	return window->vbox;
+	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(window->view));
+	if(gtk_tree_selection_get_selected(selection, NULL, &iter)) {
+
+		gtk_tree_model_get(GTK_TREE_MODEL(window->model), &iter,
+		                   PIDGIN_CONVERSATION_WINDOW_COLUMN_OBJECT, &conversation,
+		                   -1);
+	}
+
+	return conversation;
+}
+
+void
+pidgin_conversation_window_select(PidginConversationWindow *window,
+                                  PurpleConversation *conversation)
+{
+	const gchar *name = NULL;
+
+	g_return_if_fail(PIDGIN_IS_CONVERSATION_WINDOW(window));
+	g_return_if_fail(PURPLE_IS_CONVERSATION(conversation));
+
+	name = purple_conversation_get_name(conversation);
+	gtk_stack_set_visible_child_name(GTK_STACK(window->stack), name);
+}
+
+void
+pidgin_conversation_window_select_previous(PidginConversationWindow *window) {
+	GtkTreeIter iter;
+	GtkTreeModel *model = NULL;
+	GtkTreeSelection *selection = NULL;
+	gboolean set = FALSE;
+
+	g_return_if_fail(PIDGIN_IS_CONVERSATION_WINDOW(window));
+
+	model = GTK_TREE_MODEL(window->model);
+
+	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(window->view));
+	if(gtk_tree_selection_get_selected(selection, NULL, &iter)) {
+		if(gtk_tree_model_iter_previous(model, &iter)) {
+			gtk_tree_selection_select_iter(selection, &iter);
+			set = TRUE;
+		}
+	}
+
+	if(!set) {
+		pidgin_conversation_window_select_last(window);
+	}
 }
+
+
+void
+pidgin_conversation_window_select_next(PidginConversationWindow *window) {
+	GtkTreeIter iter;
+	GtkTreeModel *model = NULL;
+	GtkTreeSelection *selection = NULL;
+	gboolean set = FALSE;
+
+	g_return_if_fail(PIDGIN_IS_CONVERSATION_WINDOW(window));
+
+	model = GTK_TREE_MODEL(window->model);
+
+	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(window->view));
+	if(gtk_tree_selection_get_selected(selection, NULL, &iter)) {
+		if(gtk_tree_model_iter_next(model, &iter)) {
+			gtk_tree_selection_select_iter(selection, &iter);
+			set = TRUE;
+		}
+	}
+
+	if(!set) {
+		pidgin_conversation_window_select_first(window);
+	}
+}
+
+void
+pidgin_conversation_window_select_first(PidginConversationWindow *window) {
+	GtkTreeIter iter;
+	GtkTreeModel *model = NULL;
+
+	g_return_if_fail(PIDGIN_IS_CONVERSATION_WINDOW(window));
+
+	model = GTK_TREE_MODEL(window->model);
+
+	if(gtk_tree_model_get_iter_first(model, &iter)) {
+		GtkTreeSelection *selection = NULL;
+
+		selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(window->view));
+		gtk_tree_selection_select_iter(selection, &iter);
+	}
+}
+
+void
+pidgin_conversation_window_select_last(PidginConversationWindow *window) {
+	GtkTreeIter iter;
+	GtkTreeModel *model = NULL;
+	gint count = 0;
+
+	g_return_if_fail(PIDGIN_IS_CONVERSATION_WINDOW(window));
+
+	model = GTK_TREE_MODEL(window->model);
+	count = gtk_tree_model_iter_n_children(model, NULL);
+
+	if(gtk_tree_model_iter_nth_child(model, &iter, NULL, count - 1)) {
+		GtkTreeSelection *selection = NULL;
+
+		selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(window->view));
+		gtk_tree_selection_select_iter(selection, &iter);
+	}
+}
+
+void
+pidgin_conversation_window_select_nth(PidginConversationWindow *window,
+                                      guint nth)
+{
+	GtkTreeIter iter;
+	GtkTreeModel *model = NULL;
+
+	g_return_if_fail(PIDGIN_IS_CONVERSATION_WINDOW(window));
+
+	model = GTK_TREE_MODEL(window->model);
+
+	if(gtk_tree_model_iter_nth_child(model, &iter, NULL, nth)) {
+		GtkTreeSelection *selection = NULL;
+
+		selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(window->view));
+		gtk_tree_selection_select_iter(selection, &iter);
+	}
+}
+
+gboolean
+pidgin_conversation_window_conversation_is_selected(PidginConversationWindow *window,
+                                                    PurpleConversation *conversation)
+{
+	const gchar *name = NULL, *visible = NULL;;
+
+	g_return_val_if_fail(PIDGIN_IS_CONVERSATION_WINDOW(window), FALSE);
+	g_return_val_if_fail(PURPLE_IS_CONVERSATION(conversation), FALSE);
+
+	name = purple_conversation_get_name(conversation);
+	visible = gtk_stack_get_visible_child_name(GTK_STACK(window->stack));
+
+	return purple_strequal(name, visible);
+}
diff --git a/pidgin/pidgininfopane.c b/pidgin/pidgininfopane.c
--- a/pidgin/pidgininfopane.c
+++ b/pidgin/pidgininfopane.c
@@ -71,12 +71,12 @@
 
 		g_object_bind_property(G_OBJECT(conversation), "name",
 		                       G_OBJECT(pane->name), "label",
-		                       G_BINDING_BIDIRECTIONAL);
+		                       G_BINDING_DEFAULT | G_BINDING_SYNC_CREATE);
 
 		if(PURPLE_IS_CHAT_CONVERSATION(conversation)) {
 			g_object_bind_property(G_OBJECT(conversation), "topic",
 			                       G_OBJECT(pane->topic), "label",
-			                       G_BINDING_DEFAULT);
+			                       G_BINDING_DEFAULT | G_BINDING_SYNC_CREATE);
 			fallback = "chat";
 		} else if(PURPLE_IS_IM_CONVERSATION(conversation)){
 			PurpleAccount *account = NULL;
@@ -139,12 +139,12 @@
 }
 
 static void
-pidgin_info_pane_finalize(GObject *obj) {
+pidgin_info_pane_dispose(GObject *obj) {
 	PidginInfoPane *pane = PIDGIN_INFO_PANE(obj);
 
 	g_clear_object(&pane->conversation);
 
-	G_OBJECT_CLASS(pidgin_info_pane_parent_class)->finalize(obj);
+	G_OBJECT_CLASS(pidgin_info_pane_parent_class)->dispose(obj);
 }
 
 static void
@@ -159,7 +159,7 @@
 
 	obj_class->get_property = pidgin_info_pane_get_property;
 	obj_class->set_property = pidgin_info_pane_set_property;
-	obj_class->finalize = pidgin_info_pane_finalize;
+	obj_class->dispose = pidgin_info_pane_dispose;
 
 	/**
 	 * PidginInfoPane::conversation
diff --git a/pidgin/plugins/gestures/gestures.c b/pidgin/plugins/gestures/gestures.c
--- a/pidgin/plugins/gestures/gestures.c
+++ b/pidgin/plugins/gestures/gestures.c
@@ -48,70 +48,53 @@
 }
 
 static void
-switch_page(PidginConvWindow *win, GtkDirectionType dir)
-{
-	int count, current;
-
-	count = gtk_notebook_get_n_pages(GTK_NOTEBOOK(win->notebook));
-	current = gtk_notebook_get_current_page(GTK_NOTEBOOK(win->notebook));
-
-	if (dir == GTK_DIR_LEFT)
-	{
-		gtk_notebook_set_current_page(GTK_NOTEBOOK(win->notebook), current - 1);
-	}
-	else if (dir == GTK_DIR_RIGHT)
-	{
-		if (current == count - 1)
-			gtk_notebook_set_current_page(GTK_NOTEBOOK(win->notebook), 0);
-		else
-			gtk_notebook_set_current_page(GTK_NOTEBOOK(win->notebook), current + 1);
-	}
-}
-
-static void
 stroke_prev_tab(GtkWidget *widget, void *data)
 {
 	PurpleConversation *conv;
 	PidginConversation *gtkconv;
-	PidginConvWindow *win;
+	GtkWidget *win;
 
-	conv  = (PurpleConversation *)data;
+	conv = (PurpleConversation *)data;
 	gtkconv = PIDGIN_CONVERSATION(conv);
-	win   = gtkconv->win;
+	win = gtk_widget_get_toplevel(gtkconv->tab_cont);
 
-	switch_page(win, GTK_DIR_LEFT);
+	pidgin_conversation_window_select_previous(PIDGIN_CONVERSATION_WINDOW(win));
 }
 
 static void
 stroke_next_tab(GtkWidget *widget, void *data)
 {
 	PurpleConversation *conv;
-	PidginConvWindow *win;
+	PidginConversation *gtkconv;
+	GtkWidget *win;
 
-	conv  = (PurpleConversation *)data;
-	win   = PIDGIN_CONVERSATION(conv)->win;
+	conv = (PurpleConversation *)data;
+	gtkconv = PIDGIN_CONVERSATION(conv);
+	win = gtk_widget_get_toplevel(gtkconv->tab_cont);
 
-	switch_page(win, GTK_DIR_RIGHT);
+	pidgin_conversation_window_select_next(PIDGIN_CONVERSATION_WINDOW(win));
 }
 
 static void
 stroke_new_win(GtkWidget *widget, void *data)
 {
-	PidginConvWindow *new_win, *old_win;
+	GtkWidget *new_win, *old_win;
 	PurpleConversation *conv;
 
 	conv    = (PurpleConversation *)data;
-	old_win = PIDGIN_CONVERSATION(conv)->win;
+	old_win = gtk_widget_get_parent(PIDGIN_CONVERSATION(conv)->tab_cont);
 
-	if (pidgin_conv_window_get_gtkconv_count(old_win) <= 1)
+	if(pidgin_conversation_window_get_count(PIDGIN_CONVERSATION_WINDOW(old_win)) <= 1) {
 		return;
+	}
 
-	new_win = pidgin_conv_window_new();
+	new_win = pidgin_conversation_window_new();
 
-	pidgin_conv_window_remove_gtkconv(old_win, PIDGIN_CONVERSATION(conv));
-	pidgin_conv_window_add_gtkconv(new_win, PIDGIN_CONVERSATION(conv));
+	pidgin_conversation_window_remove(PIDGIN_CONVERSATION_WINDOW(old_win),
+	                                  conv);
+	pidgin_conversation_window_add(PIDGIN_CONVERSATION_WINDOW(new_win), conv);
 
-	pidgin_conv_window_show(new_win);
+	gtk_widget_show_all(new_win);
 }
 
 static void
diff --git a/pidgin/plugins/iconaway.c b/pidgin/plugins/iconaway.c
--- a/pidgin/plugins/iconaway.c
+++ b/pidgin/plugins/iconaway.c
@@ -29,25 +29,21 @@
 static void
 iconify_windows(PurpleAccount *account, PurpleStatus *old, PurpleStatus *newstatus)
 {
+	GApplication *application = NULL;
 	PurplePresence *presence;
-	PidginConvWindow *win;
 	GList *windows;
 
 	presence = purple_status_get_presence(newstatus);
 
-	if (purple_presence_is_available(presence))
+	if(purple_presence_is_available(presence)) {
 		return;
+	}
 
 	purple_blist_set_visible(FALSE);
 
-	for (windows = pidgin_conv_windows_get_list();
-		 windows != NULL;
-		 windows = windows->next) {
-
-		win = (PidginConvWindow *)windows->data;
-
-		gtk_window_iconify(GTK_WINDOW(win->window));
-	}
+	application = g_application_get_default();
+	windows = gtk_application_get_windows(GTK_APPLICATION(application));
+	g_list_foreach(windows, (GFunc)gtk_window_iconify, NULL);
 }
 
 /*
diff --git a/pidgin/plugins/notify.c b/pidgin/plugins/notify.c
--- a/pidgin/plugins/notify.c
+++ b/pidgin/plugins/notify.c
@@ -125,9 +125,6 @@
 /* urgent function */
 static void handle_urgent(PidginConvWindow *purplewin, gboolean set);
 
-/* raise function */
-static void handle_raise(PidginConvWindow *purplewin);
-
 /* present function */
 static void handle_present(PurpleConversation *conv);
 
@@ -203,8 +200,6 @@
 		handle_string(purplewin);
 	if (purple_prefs_get_bool("/plugins/gtk/X11/notify/method_urgent"))
 		handle_urgent(purplewin, TRUE);
-	if (purple_prefs_get_bool("/plugins/gtk/X11/notify/method_raise"))
-		handle_raise(purplewin);
 	if (purple_prefs_get_bool("/plugins/gtk/X11/notify/method_present"))
 		handle_present(conv);
 }
@@ -213,14 +208,17 @@
 unnotify(PurpleConversation *conv, gboolean reset)
 {
 	PurpleConversation *active_conv = NULL;
-	PidginConvWindow *purplewin = NULL;
+	PidginConversationWindow *purplewin = NULL;
+	GtkWidget *win;
 
 	g_return_if_fail(conv != NULL);
 	if (PIDGIN_CONVERSATION(conv) == NULL)
 		return;
 
-	purplewin = PIDGIN_CONVERSATION(conv)->win;
-	active_conv = pidgin_conv_window_get_active_conversation(purplewin);
+	win = gtk_widget_get_toplevel(PIDGIN_CONVERSATION(conv)->tab_cont);
+	purplewin = PIDGIN_CONVERSATION_WINDOW(win);
+
+	activate_conv = pidgin_conversation_window_get_selected(purplewin);
 
 	/* reset the conversation window title */
 	purple_conversation_autoset_title(active_conv);
@@ -569,12 +567,6 @@
 }
 
 static void
-handle_raise(PidginConvWindow *purplewin)
-{
-	pidgin_conv_window_raise(purplewin);
-}
-
-static void
 handle_present(PurpleConversation *conv)
 {
 	if (pidgin_conv_is_hidden(PIDGIN_CONVERSATION(conv)))
diff --git a/pidgin/plugins/unity.c b/pidgin/plugins/unity.c
--- a/pidgin/plugins/unity.c
+++ b/pidgin/plugins/unity.c
@@ -149,14 +149,19 @@
 alert(PurpleConversation *conv)
 {
 	gint count;
-	PidginConvWindow *purplewin = NULL;
+	PidginConversation *gtkconv = NULL;
+	PidginConversationWindow *purplewin = NULL;
+	GtkWidget *win = NULL;
+
 	if (conv == NULL || PIDGIN_CONVERSATION(conv) == NULL)
 		return 0;
 
-	purplewin = PIDGIN_CONVERSATION(conv)->win;
+	gtkconv = PIDGIN_CONVERSATION(conv);
+	win = gtk_widget_get_toplevel(gtkconv->pane);
+	purplewin = PIDGIN_CONVERSATION_WINDOW(win);
 
-	if (!pidgin_conv_window_has_focus(purplewin) ||
-		!pidgin_conv_window_is_active_conversation(conv))
+	if (!pidgin_conversation_window_has_focus(purplewin) ||
+		!pidgin_conversation_window_conversation_is_selected(purplewin, conv))
 	{
 		count = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(conv),
 				"unity-message-count"));
@@ -256,7 +261,6 @@
 	PurpleConversation *conv = NULL;
 	PurpleConversationManager *manager = NULL;
 	PurpleAccount *account;
-	PidginConvWindow *purplewin = NULL;
 
 	char *type     = sections[0];
 	char *cname    = sections[1];
@@ -276,10 +280,16 @@
 	}
 
 	if (conv) {
+		GtkWidget *win = NULL;
+		PidginConversationWindow *convwin = NULL;
+
+		win = gtk_widget_get_toplevel(PIDGIN_CONVERSATION(conv)->tab_cont);
+		convwin = PIDGIN_CONVERSATION_WINDOW(win);
+
 		unalert(conv);
-		purplewin = PIDGIN_CONVERSATION(conv)->win;
-		pidgin_conv_window_switch_gtkconv(purplewin, PIDGIN_CONVERSATION(conv));
-		gdk_window_focus(gtk_widget_get_window(purplewin->window), time(NULL));
+
+		pidgin_conversation_window_select(convwin, conv);
+		gdk_window_focus(gtk_widget_get_window(win), time(NULL));
 	}
 	g_strfreev (sections);
 }
diff --git a/pidgin/resources/Conversations/infopane.ui b/pidgin/resources/Conversations/infopane.ui
--- a/pidgin/resources/Conversations/infopane.ui
+++ b/pidgin/resources/Conversations/infopane.ui
@@ -57,7 +57,7 @@
               <object class="GtkLabel" id="name">
                 <property name="visible">True</property>
                 <property name="can-focus">False</property>
-                <property name="label" translatable="yes">testing</property>
+                <property name="label" translatable="yes">[Place Holder]</property>
                 <property name="xalign">0</property>
                 <attributes>
                   <attribute name="weight" value="bold"/>
diff --git a/pidgin/resources/Conversations/menu.ui b/pidgin/resources/Conversations/menu.ui
--- a/pidgin/resources/Conversations/menu.ui
+++ b/pidgin/resources/Conversations/menu.ui
@@ -46,10 +46,6 @@
           <attribute name="accel">&lt;Primary&gt;F</attribute>
         </item>
         <item>
-          <attribute name="label" translatable="yes">_Save As...</attribute>
-          <attribute name="action">win.save-as</attribute>
-        </item>
-        <item>
           <attribute name="label" translatable="yes">Clea_r Scrollback</attribute>
           <attribute name="action">win.clear-history</attribute>
           <attribute name="accel">&lt;Primary&gt;L</attribute>
@@ -99,20 +95,12 @@
           <attribute name="action">win.alias</attribute>
         </item>
         <item>
-          <attribute name="label" translatable="yes">_Block...</attribute>
+          <attribute name="label" translatable="yes">_Blocked...</attribute>
           <attribute name="action">win.block</attribute>
         </item>
         <item>
-          <attribute name="label" translatable="yes">_Unblock...</attribute>
-          <attribute name="action">win.unblock</attribute>
-        </item>
-        <item>
-          <attribute name="label" translatable="yes">_Add...</attribute>
-          <attribute name="action">win.add</attribute>
-        </item>
-        <item>
-          <attribute name="label" translatable="yes">_Remove...</attribute>
-          <attribute name="action">win.remove</attribute>
+          <attribute name="label" translatable="yes">_Save Contact</attribute>
+          <attribute name="action">win.save-contact</attribute>
         </item>
       </section>
       <section>
diff --git a/pidgin/resources/Conversations/window.ui b/pidgin/resources/Conversations/window.ui
--- a/pidgin/resources/Conversations/window.ui
+++ b/pidgin/resources/Conversations/window.ui
@@ -20,11 +20,21 @@
 
 -->
 <interface>
-  <requires lib="gtk+" version="3.22"/>
+  <requires lib="gtk+" version="3.24"/>
   <!-- interface-license-type gplv2 -->
   <!-- interface-name Pidgin -->
   <!-- interface-description Internet Messenger -->
   <!-- interface-copyright Pidgin Developers <devel@pidgin.im> -->
+  <object class="GtkTreeStore" id="model">
+    <columns>
+      <!-- column-name conversation -->
+      <column type="GObject"/>
+      <!-- column-name icon -->
+      <column type="GdkPixbuf"/>
+      <!-- column-name markup -->
+      <column type="gchararray"/>
+    </columns>
+  </object>
   <template class="PidginConversationWindow" parent="GtkApplicationWindow">
     <property name="can-focus">False</property>
     <property name="role">conversation</property>
@@ -34,7 +44,81 @@
         <property name="can-focus">False</property>
         <property name="orientation">vertical</property>
         <child>
-          <placeholder/>
+          <object class="GtkPaned" id="paned">
+            <property name="visible">True</property>
+            <property name="can-focus">True</property>
+            <property name="position">100</property>
+            <property name="wide-handle">True</property>
+            <child>
+              <object class="GtkScrolledWindow">
+                <property name="visible">True</property>
+                <property name="can-focus">True</property>
+                <property name="shadow-type">in</property>
+                <property name="propagate-natural-width">True</property>
+                <child>
+                  <object class="GtkTreeView" id="view">
+                    <property name="visible">True</property>
+                    <property name="can-focus">True</property>
+                    <property name="model">model</property>
+                    <property name="headers-visible">False</property>
+                    <property name="search-column">2</property>
+                    <child internal-child="selection">
+                      <object class="GtkTreeSelection">
+                        <signal name="changed" handler="pidgin_conversation_window_selection_changed" object="PidginConversationWindow" swapped="no"/>
+                      </object>
+                    </child>
+                    <child>
+                      <object class="GtkTreeViewColumn" id="markup">
+                        <child>
+                          <object class="GtkCellRendererPixbuf" id="icon"/>
+                          <attributes>
+                            <attribute name="pixbuf">1</attribute>
+                          </attributes>
+                        </child>
+                        <child>
+                          <object class="GtkCellRendererText" id="name"/>
+                          <attributes>
+                            <attribute name="markup">2</attribute>
+                          </attributes>
+                        </child>
+                      </object>
+                    </child>
+                  </object>
+                </child>
+              </object>
+              <packing>
+                <property name="resize">True</property>
+                <property name="shrink">True</property>
+              </packing>
+            </child>
+            <child>
+              <object class="GtkStack" id="stack">
+                <property name="visible">True</property>
+                <property name="can-focus">False</property>
+                <child>
+                  <object class="GtkLabel">
+                    <property name="visible">True</property>
+                    <property name="can-focus">False</property>
+                    <property name="label" translatable="yes">Select a conversation to chat!</property>
+                  </object>
+                  <packing>
+                    <property name="name">__empty__</property>
+                    <property name="title" translatable="yes">__empty__</property>
+                  </packing>
+                </child>
+              </object>
+              <packing>
+                <property name="resize">True</property>
+                <property name="shrink">True</property>
+              </packing>
+            </child>
+          </object>
+          <packing>
+            <property name="expand">True</property>
+            <property name="fill">True</property>
+            <property name="pack-type">end</property>
+            <property name="position">0</property>
+          </packing>
         </child>
       </object>
     </child>
